/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.controller;

import id.go.bpkp.ski.ejb.CrudEJB;
import java.io.Serializable;
import javax.annotation.PostConstruct;
import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authc.UsernamePasswordToken;
import org.apache.shiro.subject.Subject;
import org.primefaces.context.RequestContext;

/**
 *
 * @author phai
 */
@Named
@SessionScoped
public class AuthBean implements Serializable {

    @Inject
    CrudEJB crudEJB;
    private String username;
    private String password;

    @PostConstruct
    public void init() {
    }

    public String login() {
        String nextPage = null;

        RequestContext context = RequestContext.getCurrentInstance();
        FacesMessage msg = null;

        boolean isAuth = true;
        UsernamePasswordToken token = new UsernamePasswordToken(username, password);

        Subject subject = SecurityUtils.getSubject();
        try {
            subject.login(token);
            token.clear();
        } catch (Exception e) { // jika gagal login
            isAuth = false;
            e.printStackTrace();
        }
        if (isAuth) { // jika berhasil login
            nextPage = "/index";
        } else {
            msg = new FacesMessage(FacesMessage.SEVERITY_ERROR, "Login Error", "Invalid username or password");
            FacesContext.getCurrentInstance().addMessage(null, msg);
            nextPage = "/login";
        }
        return nextPage;
    }
    
    public String logout(){
        Subject subject = SecurityUtils.getSubject();
        subject.logout();
        return "/index?faces-redirect=true";
    }
    
    public String goToIndex(){
        System.err.println("goToIndex");
        return "/rencanakinerja/list?faces-redirect=true";
    }

    public boolean isLoggedIn() {
        Subject subject = SecurityUtils.getSubject();
        return subject.isAuthenticated();
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }
}
