/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.controller.converter;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import javax.enterprise.context.Conversation;
import javax.enterprise.context.ConversationScoped;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.FacesConverter;
import javax.inject.Inject;

/**
 * A basic converter that works with any kind of object. NOTE: It should only be
 * used in long running conversations!
 *
 * @author <a href="http://community.jboss.org/people/LightGuard">Jason
 * Porter</a>a>
 */
//@ConversationScoped
@FacesConverter("objectConverter")
public class ObjectConverter implements javax.faces.convert.Converter, Serializable {

    private static final long serialVersionUID = -406332789399557968L;
    final private Map<String, Object> stringObjectMap = new HashMap<String, Object>();
    final private Map<Object, String> objectStringMap = new HashMap<Object, String>();
//    @Inject
//    private transient Conversation conversation;
    private int incrementor = 1;

    @Override
    public Object getAsObject(FacesContext context, UIComponent component, String value) {
//        if (this.conversation.isTransient()) {
//            System.err.println("Conversion attempted without a long running conversation");
//        }

        return this.stringObjectMap.get(value);
    }

    @Override
    public String getAsString(FacesContext context, UIComponent component, Object value) {
//        if (this.conversation.isTransient()) {
//            System.err.println("Conversion attempted without a long running conversation");
//        }

        if (this.objectStringMap.containsKey(value)) {
            return this.objectStringMap.get(value);
        } else {
            final String incrementorStringValue = String.valueOf(this.incrementor++);
            this.stringObjectMap.put(incrementorStringValue, value);
            this.objectStringMap.put(value, incrementorStringValue);
            return incrementorStringValue;
        }
    }
}
