/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.controller.rencanakinerja;

import id.go.bpkp.ski.ejb.CrudEJB;
import id.go.bpkp.ski.ejb.QueryParameter;
import id.go.bpkp.ski.entity.*;
import java.io.Serializable;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.SessionScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.inject.Inject;
import javax.inject.Named;
import org.primefaces.context.RequestContext;

/**
 *
 * @author phai
 */
@Named
@SessionScoped
public class RencanaKinerjaController implements Serializable {

    @Inject
    private CrudEJB crudEJB;
    private Runit unitKerja;
    private Periode periode;
    private UnitKerjaPeriode unitKerjaPeriode;
    private RencanaKinerja rencanaKinerja;
    private RencanaKinerjaPegawai rencanaKinerjaPegawai;
    private Rpegawai pegawai;
    private Rpegawai pegawaiAtasan;
    private Rpegawai pegawaiAtasanAtasan;
    private List<Runit> unitKerjas;
    private List<Periode> periodes;
    private DataModel<RencanaKinerjaPegawai> rencanaKinerjaPegawais;
    private List<Rpegawai> pegawais;

    @PostConstruct
    public void init() {
        System.err.println("===INIT===");
        unitKerjas = crudEJB.findWithNamedQuery("Runit.findAll");
        periodes = crudEJB.findWithNamedQuery("Periode.findAll");
    }

    @PreDestroy
    public void destroy() {
        System.err.println("===DESTROY===");
        unitKerja = null;
        periode = null;
        unitKerjaPeriode = null;
        rencanaKinerja = null;
        rencanaKinerjaPegawai = null;
        if (null != unitKerjas) {
            unitKerjas.clear();
            unitKerjas = null;
        }
        if (null != periodes) {
            periodes.clear();
            periodes = null;
        }
        rencanaKinerjaPegawais = null;
    }

    public void onChangeUnitKerja() {
        setRencanaKinerja();
    }

    public void onChangePeriode() {
        setRencanaKinerja();
    }

    public void onChangePegawai() {
        rencanaKinerjaPegawai.setRpegawaiFk(pegawai);
    }

    public void onChangePegawaiAtasan() {
        rencanaKinerjaPegawai.setRpegawaiAtasanFk(pegawaiAtasan);
    }

    public void onChangePegawaiAtasanAtasan() {
        rencanaKinerjaPegawai.setRpegawaiAtasanAtasanFk(pegawaiAtasanAtasan);
    }

    private void setRencanaKinerja() {
        unitKerjaPeriode = null;
        rencanaKinerja = null;
        rencanaKinerjaPegawais = null;
        if (unitKerja != null && periode != null) {
            List<UnitKerjaPeriode> listUnitKerjaPeriode = crudEJB.findWithNamedQuery("UnitKerjaPeriode.findByUnitKerjaAndPeriode",
                    QueryParameter.with("runitPk", unitKerja.getRunitPk()).and("periodePk", periode.getPeriodePk()).parameters());

            if (!listUnitKerjaPeriode.isEmpty()) {
                unitKerjaPeriode = listUnitKerjaPeriode.get(0);
            }
            if (unitKerjaPeriode != null) {
                List<RencanaKinerja> listRencanaKinerja = (List<RencanaKinerja>) unitKerjaPeriode.getRencanaKinerjaCollection();
                if (!listRencanaKinerja.isEmpty()) {
                    rencanaKinerja = listRencanaKinerja.get(0);
                }
            }

            if (rencanaKinerja != null) {
                List<RencanaKinerjaPegawai> listIseng = crudEJB.findWithNamedQuery("RencanaKinerjaPegawai.findAll");
                List<RencanaKinerjaPegawai> listRencanaKinerjaPegawai = (List<RencanaKinerjaPegawai>) rencanaKinerja.getRencanaKinerjaPegawaiCollection();
                rencanaKinerjaPegawais = new ListDataModel(listRencanaKinerjaPegawai);
            }
        }
    }

    public String add() {
        if (periode != null && unitKerja != null) {
            if (unitKerjaPeriode == null) {
                unitKerjaPeriode = new UnitKerjaPeriode();
                unitKerjaPeriode.setRunitFk(unitKerja);
                unitKerjaPeriode.setPeriodeFk(periode);
                unitKerjaPeriode = crudEJB.create(unitKerjaPeriode);
            }
            if (rencanaKinerja == null) {
                rencanaKinerja = new RencanaKinerja();
                rencanaKinerja.setUnitKerjaPeriodeFk(unitKerjaPeriode);
                rencanaKinerja = crudEJB.create(rencanaKinerja);
            }

            rencanaKinerjaPegawai = new RencanaKinerjaPegawai();
            rencanaKinerjaPegawai.setRencanaKinerjaFk(rencanaKinerja);
            pegawais = crudEJB.findWithNamedQuery("Rpegawai.findAll");
            pegawai = null;
            pegawaiAtasanAtasan = null;
            pegawaiAtasan = null;
            return "/rencanakinerja/create?faces-redirect=true";
        } else {
            RequestContext context = RequestContext.getCurrentInstance();
            FacesMessage msg = new FacesMessage(FacesMessage.SEVERITY_ERROR, "Unit Kerja & Periode masih kosong", "Silakan pilih Unit Kerja & Periode");
            FacesContext.getCurrentInstance().addMessage(null, msg);
            return "";
        }
    }

    public String edit() {
        rencanaKinerjaPegawai = rencanaKinerjaPegawais.getRowData();
        pegawai = rencanaKinerjaPegawai.getRpegawaiFk();
        pegawaiAtasan = rencanaKinerjaPegawai.getRpegawaiAtasanFk();
        pegawaiAtasanAtasan = rencanaKinerjaPegawai.getRpegawaiAtasanAtasanFk();
        pegawais = crudEJB.findWithNamedQuery("Rpegawai.findAll");
        return "/rencanakinerja/edit?faces-redirect=true";
    }

    public String delete() {
        rencanaKinerjaPegawai = rencanaKinerjaPegawais.getRowData();
        return "/rencanakinerja/delete?faces-redirect=true";
    }

    public String review() {
        return "";
    }

    public String save() {
        if (rencanaKinerjaPegawai != null) {
            if (rencanaKinerjaPegawai.getRencanaKinerjaPegawaiPk() == null) {
                rencanaKinerjaPegawai = crudEJB.create(rencanaKinerjaPegawai);
            } else {
                System.err.println("save : " + rencanaKinerjaPegawai.getRencanaKinerjaPegawaiPk());
                rencanaKinerjaPegawai = crudEJB.update(rencanaKinerjaPegawai);
            }
        }
        setRencanaKinerja();
        return "/rencanakinerja/peran/list?faces-redirect=true";
    }

    public String remove() {
        crudEJB.delete(RencanaKinerjaPegawai.class, rencanaKinerjaPegawai.getRencanaKinerjaPegawaiPk());
        setRencanaKinerja();
        return "/rencanakinerja/list?faces-redirect=true";
    }

    public Rpegawai getPegawai() {
        return pegawai;
    }

    public void setPegawai(Rpegawai pegawai) {
        this.pegawai = pegawai;
    }

    public List<Rpegawai> getPegawais() {
        return pegawais;
    }

    public void setPegawais(List<Rpegawai> pegawais) {
        this.pegawais = pegawais;
    }

    public Periode getPeriode() {
        return periode;
    }

    public void setPeriode(Periode periode) {
        this.periode = periode;
    }

    public List<Periode> getPeriodes() {
        return periodes;
    }

    public void setPeriodes(List<Periode> periodes) {
        this.periodes = periodes;
    }

    public RencanaKinerja getRencanaKinerja() {
        return rencanaKinerja;
    }

    public void setRencanaKinerja(RencanaKinerja rencanaKinerja) {
        this.rencanaKinerja = rencanaKinerja;
    }

    public RencanaKinerjaPegawai getRencanaKinerjaPegawai() {
        return rencanaKinerjaPegawai;
    }

    public void setRencanaKinerjaPegawai(RencanaKinerjaPegawai rencanaKinerjaPegawai) {
        this.rencanaKinerjaPegawai = rencanaKinerjaPegawai;
    }

    public DataModel<RencanaKinerjaPegawai> getRencanaKinerjaPegawais() {
        setRencanaKinerja();
        return rencanaKinerjaPegawais;
    }

    public void setRencanaKinerjaPegawais(DataModel<RencanaKinerjaPegawai> rencanaKinerjaPegawais) {
        this.rencanaKinerjaPegawais = rencanaKinerjaPegawais;
    }

    public Runit getUnitKerja() {
        return unitKerja;
    }

    public void setUnitKerja(Runit unitKerja) {
        this.unitKerja = unitKerja;
    }

    public List<Runit> getUnitKerjas() {
        return unitKerjas;
    }

    public void setUnitKerjas(List<Runit> unitKerjas) {
        this.unitKerjas = unitKerjas;
    }

    public UnitKerjaPeriode getUnitKerjaPeriode() {
        return unitKerjaPeriode;
    }

    public void setUnitKerjaPeriode(UnitKerjaPeriode unitKerjaPeriode) {
        this.unitKerjaPeriode = unitKerjaPeriode;
    }

    public Rpegawai getPegawaiAtasan() {
        return pegawaiAtasan;
    }

    public void setPegawaiAtasan(Rpegawai pegawaiAtasan) {
        this.pegawaiAtasan = pegawaiAtasan;
    }

    public Rpegawai getPegawaiAtasanAtasan() {
        return pegawaiAtasanAtasan;
    }

    public void setPegawaiAtasanAtasan(Rpegawai pegawaiAtasanAtasan) {
        this.pegawaiAtasanAtasan = pegawaiAtasanAtasan;
    }
}
