/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.controller.rencanakinerja;

import id.go.bpkp.ski.ejb.CrudEJB;
import id.go.bpkp.ski.ejb.QueryParameter;
import id.go.bpkp.ski.entity.*;
import java.io.Serializable;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.RequestScoped;
import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.inject.Inject;
import javax.inject.Named;
import org.primefaces.context.RequestContext;

/**
 *
 * @author phai
 */
@Named
@RequestScoped
public class RencanaKinerjaIndexBean implements Serializable {

    @Inject
    private RencanaKinerjaBean rencanaKinerjaBean;
    @Inject
    private CrudEJB crudEJB;
    private List<Runit> unitKerjas;
    private List<Periode> periodes;
    private DataModel<RencanaKinerjaPegawai> rencanaKinerjaPegawais;
    private Runit selectedUnitKerja;
    private Periode selectedPeriode;
    private RencanaKinerja currentRencanaKinerja;
    private RencanaKinerjaPegawai selectedRencanaKinerjaPegawai;

    @PostConstruct
    public void init() {
        System.err.println("=== INIT ===");
        selectedUnitKerja = rencanaKinerjaBean.getSelectedRunit();
        selectedPeriode = rencanaKinerjaBean.getSelectedPeriode();
        currentRencanaKinerja = rencanaKinerjaBean.getCurrentRencanaKinerja();

        unitKerjas = crudEJB.findWithNamedQuery("Runit.findAll");
        periodes = crudEJB.findWithNamedQuery("Periode.findAll");
    }

    @PreDestroy
    public void destroy() {
        System.err.println("=== DESTROY ===");
        selectedUnitKerja = null;
        selectedPeriode = null;
        currentRencanaKinerja = null;
        if (null != unitKerjas) {
            unitKerjas.clear();
            unitKerjas = null;
        }
        if (null != periodes) {
            periodes.clear();
            periodes = null;
        }
        if (null != rencanaKinerjaPegawais) {
            rencanaKinerjaPegawais = null;
        }
    }

    public void onChangeUnitKerja(ValueChangeEvent e) {
        System.err.println("=== onChangeUnitKerja ===");

        Runit newRunit = (Runit) e.getNewValue();
        setCurrentRencanaKinerja(newRunit, selectedPeriode);
        rencanaKinerjaBean.setSelectedRunit(newRunit);

        if (selectedPeriode == null) {
            System.err.println("selectedPeriode null");
        }
    }

    public void onChangePeriode(ValueChangeEvent e) {
        System.err.println("=== onChangePeriode ===");

        Periode newPeriode = (Periode) e.getNewValue();
        setCurrentRencanaKinerja(selectedUnitKerja, newPeriode);
        rencanaKinerjaBean.setSelectedPeriode(newPeriode);

        if (selectedUnitKerja == null) {
            System.err.println("selectedUnitKerja null");
        }
    }

    private void setCurrentRencanaKinerja(Runit unitKerja, Periode periode) {
        System.err.println("=== setCurrentRencanaKinerja ===");

        currentRencanaKinerja = null;
        rencanaKinerjaPegawais = null;
        if (unitKerja != null && periode != null) {
            System.err.println("UnitKerja : " + unitKerja.getRunitPk());
            System.err.println("Periode : " + periode.getPeriodePk());

            List<UnitKerjaPeriode> listUnitKerjaPeriode = crudEJB.findWithNamedQuery("UnitKerjaPeriode.findByUnitKerjaAndPeriode",
                    QueryParameter.with("runitPk", unitKerja.getRunitPk()).and("periodePk", periode.getPeriodePk()).parameters());

            UnitKerjaPeriode unitKerjaPeriode = null;
            if (!listUnitKerjaPeriode.isEmpty()) {
                unitKerjaPeriode = listUnitKerjaPeriode.get(0);
            }
            if (unitKerjaPeriode != null) {
                List<RencanaKinerja> listRencanaKinerja = (List<RencanaKinerja>) unitKerjaPeriode.getRencanaKinerjaCollection();
                if (!listRencanaKinerja.isEmpty()) {
                    currentRencanaKinerja = listRencanaKinerja.get(0);
                }
            }

            rencanaKinerjaBean.setCurrentRencanaKinerja(currentRencanaKinerja);

            if (currentRencanaKinerja != null) {
                List<RencanaKinerjaPegawai> listIseng = crudEJB.findWithNamedQuery("RencanaKinerjaPegawai.findAll");
                List<RencanaKinerjaPegawai> listRencanaKinerjaPegawai = (List<RencanaKinerjaPegawai>) currentRencanaKinerja.getRencanaKinerjaPegawaiCollection();
                rencanaKinerjaPegawais = new ListDataModel(listRencanaKinerjaPegawai);

                System.err.println("MASUK rencanaKinerjaPK = "
                        + currentRencanaKinerja.getRencanaKinerjaPk()
                        + " rowcountModel = " + rencanaKinerjaPegawais.getRowCount()
                        + " sizeList = " + listRencanaKinerjaPegawai.size()
                        + " sizeListIseng = " + listIseng.size());
            }
        }
    }

    public String addRencanaKinerjaPegawai() {
        if (rencanaKinerjaBean.getSelectedPeriode() == null || rencanaKinerjaBean.getSelectedRunit() == null) {
            RequestContext context = RequestContext.getCurrentInstance();
            FacesMessage msg = new FacesMessage(FacesMessage.SEVERITY_ERROR, "Unit Kerja & Periode masih kosong", "Silakan pilih Unit Kerja & Periode");
            FacesContext.getCurrentInstance().addMessage(null, msg);
            return "";
        } else {
            selectedRencanaKinerjaPegawai = new RencanaKinerjaPegawai();
            rencanaKinerjaBean.setSelectedRencanaKinerjaPegawai(selectedRencanaKinerjaPegawai);
            System.err.println("addRencanaKinerjaPegawai");
            return "/rencanakinerja/create?faces-redirect=true";
        }
    }

    public String editRencanaKinerjaPegawai() {
        selectedRencanaKinerjaPegawai = rencanaKinerjaPegawais.getRowData();
        rencanaKinerjaBean.setSelectedRencanaKinerjaPegawai(selectedRencanaKinerjaPegawai);
        System.err.println("editRencanaKinerjaPegawai " + selectedRencanaKinerjaPegawai.getRpegawaiFk().getPegawaicode());
        return "/rencanakinerja/edit?faces-redirect=true";
    }

    public String deleteRencanaKinerjaPegawai() {
        selectedRencanaKinerjaPegawai = rencanaKinerjaPegawais.getRowData();
        rencanaKinerjaBean.setSelectedRencanaKinerjaPegawai(selectedRencanaKinerjaPegawai);
        System.err.println("deleteRencanaKinerjaPegawai " + selectedRencanaKinerjaPegawai.getRpegawaiFk().getPegawaicode());
        return "/rencanakinerja/delete?faces-redirect=true";
    }

    public String reviewRencanaKinerjaPegawai() {
        return "";
    }

    public RencanaKinerja getCurrentRencanaKinerja() {
        setCurrentRencanaKinerja(selectedUnitKerja, selectedPeriode);
        return currentRencanaKinerja;
    }

    public void setCurrentRencanaKinerja(RencanaKinerja currentRencanaKinerja) {
        this.currentRencanaKinerja = currentRencanaKinerja;
    }

    public List<Periode> getPeriodes() {
        return periodes;
    }

    public void setPeriodes(List<Periode> periodes) {
        this.periodes = periodes;
    }

    public DataModel<RencanaKinerjaPegawai> getRencanaKinerjaPegawais() {
        setCurrentRencanaKinerja(selectedUnitKerja, selectedPeriode);
        return rencanaKinerjaPegawais;
    }

    public void setRencanaKinerjaPegawais(DataModel<RencanaKinerjaPegawai> rencanaKinerjaPegawais) {
        this.rencanaKinerjaPegawais = rencanaKinerjaPegawais;
    }

    public Periode getSelectedPeriode() {
        return selectedPeriode;
    }

    public void setSelectedPeriode(Periode selectedPeriode) {
        this.selectedPeriode = selectedPeriode;
    }

    public RencanaKinerjaPegawai getSelectedRencanaKinerjaPegawai() {
        return selectedRencanaKinerjaPegawai;
    }

    public void setSelectedRencanaKinerjaPegawai(RencanaKinerjaPegawai selectedRencanaKinerjaPegawai) {
        this.selectedRencanaKinerjaPegawai = selectedRencanaKinerjaPegawai;
    }

    public Runit getSelectedUnitKerja() {
        return selectedUnitKerja;
    }

    public void setSelectedUnitKerja(Runit selectedUnitKerja) {
        this.selectedUnitKerja = selectedUnitKerja;
    }

    public List<Runit> getUnitKerjas() {
        return unitKerjas;
    }

    public void setUnitKerjas(List<Runit> unitKerjas) {
        this.unitKerjas = unitKerjas;
    }
}
