/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.controller.rencanakinerja;

import id.go.bpkp.ski.ejb.CrudEJB;
import id.go.bpkp.ski.entity.*;
import java.io.Serializable;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.SessionScoped;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.inject.Inject;
import javax.inject.Named;

/**
 *
 * @author phai
 */
@Named
@SessionScoped
public class RencanaKinerjaIndikatorController implements Serializable {

    @Inject
    private CrudEJB crudEJB;
    @Inject
    private RencanaKinerjaSasaranController rencanaKinerjaSasaranController;
    @Inject
    private RencanaKinerjaPeranController rencanaKinerjaPeranController;
    private Runit unitKerja;
    private Periode periode;
    private Rpegawai pegawai;
    private PegawaiPeran pegawaiPeran;
    private PeranSasaran peranSasaran;
    private SasaranIndikatorKinerja sasaranIndikator;
    private Sasaran sasaran;
    private IndikatorKinerja indikator;
    private DataModel<SasaranIndikatorKinerja> sasaranIndikators;
    private List<IndikatorKinerja> indikators;
    private List<PegawaiPeran> pegawaiPerans;
    private List<PeranSasaran> peranSasarans;

    @PostConstruct
    public void init() {
        System.err.println("===INIT===");
        unitKerja = rencanaKinerjaSasaranController.getUnitKerja();
        periode = rencanaKinerjaSasaranController.getPeriode();
        pegawai = rencanaKinerjaSasaranController.getPegawai();

        pegawaiPeran = rencanaKinerjaPeranController.getPegawaiPeran();
        pegawaiPerans = (List<PegawaiPeran>) rencanaKinerjaPeranController.getRencanaKinerjaPegawai().getPegawaiPeranCollection();

        peranSasaran = rencanaKinerjaSasaranController.getPeranSasaran();
        sasaran = peranSasaran.getSasaranFk();

        peranSasarans = (List<PeranSasaran>) pegawaiPeran.getPeranSasaranCollection();

        refreshSasaranIndikators();
    }

    @PreDestroy
    public void destroy() {
        System.err.println("===DESTROY===");
        unitKerja = null;
        periode = null;
        pegawai = null;
        peranSasaran = null;
        sasaranIndikator = null;
        sasaranIndikators = null;

        if (null != indikators) {
            indikators.clear();
            indikators = null;
        }
    }

    public void onChangeIndikator() {
        System.err.println("onChangeIndikator");
        sasaranIndikator.setIndikatorKinerjaFk(indikator);
    }

    public void onChangePeranSasaran() {
        rencanaKinerjaSasaranController.setPeranSasaran(peranSasaran);
        refreshSasaranIndikators();
    }

    public void onChangePegawaiPeran() {
        rencanaKinerjaPeranController.setPegawaiPeran(pegawaiPeran);
        rencanaKinerjaSasaranController.setPeranSasaran(null);
        peranSasarans = (List<PeranSasaran>) pegawaiPeran.getPeranSasaranCollection();
        sasaranIndikators = null;
    }

    public String add() {
        System.err.println("Sasaran Add");
        if (peranSasaran != null) {
            sasaranIndikator = new SasaranIndikatorKinerja();
            System.err.println("Sasaran Add TIDAK NULL");
            sasaranIndikator.setPeranSasaranFk(peranSasaran);
            indikators = (List<IndikatorKinerja>) sasaran.getIndikatorKinerjaCollection();
            indikator = null;
            return "/rencanakinerja/indikator/create?faces-redirect=true";
        } else {
            return "/rencanakinerja/sasaran/list?faces-redirect=true";
        }
    }

    public String edit() {
        sasaranIndikator = sasaranIndikators.getRowData();
        indikator = sasaranIndikator.getIndikatorKinerjaFk();
        indikators = (List<IndikatorKinerja>) sasaran.getIndikatorKinerjaCollection();
        return "/rencanakinerja/indikator/edit?faces-redirect=true";
    }

    public String delete() {
        sasaranIndikator = sasaranIndikators.getRowData();
        return "/rencanakinerja/indikator/delete?faces-redirect=true";
    }

    public String save() {
        System.err.println("masuk save");
        if (sasaranIndikator != null) {
            if (sasaranIndikator.getSasaranIndikatorKinerjaPk() == null) {
                sasaranIndikator = crudEJB.create(sasaranIndikator);
            } else {
                sasaranIndikator = crudEJB.update(sasaranIndikator);
            }
        }
        refreshSasaranIndikators();

        return "/rencanakinerja/indikator/list?faces-redirect=true";
    }

    public String remove() {
        crudEJB.delete(PeranSasaran.class, getPeranSasaran().getPeranSasaranPk());
        refreshSasaranIndikators();
        return "/rencanakinerja/indikator/list?faces-redirect=true";
    }

    private void refreshSasaranIndikators() {
        if (getPeranSasaran() != null) {
            peranSasaran = crudEJB.find(PeranSasaran.class, getPeranSasaran().getPeranSasaranPk());
            List<SasaranIndikatorKinerja> listSasaranIndikator = (List<SasaranIndikatorKinerja>) peranSasaran.getSasaranIndikatorKinerjaCollection();
            sasaranIndikators = new ListDataModel<SasaranIndikatorKinerja>(listSasaranIndikator);
        }
    }

    public IndikatorKinerja getIndikator() {
        return indikator;
    }

    public void setIndikator(IndikatorKinerja indikator) {
        this.indikator = indikator;
    }

    public List<IndikatorKinerja> getIndikators() {
        return indikators;
    }

    public void setIndikators(List<IndikatorKinerja> indikators) {
        this.indikators = indikators;
    }

    public Rpegawai getPegawai() {
        pegawai = rencanaKinerjaSasaranController.getPegawai();
        return pegawai;
    }

    public void setPegawai(Rpegawai pegawai) {
        this.pegawai = pegawai;
    }

    public PeranSasaran getPeranSasaran() {
        peranSasaran = rencanaKinerjaSasaranController.getPeranSasaran();
        return peranSasaran;
    }

    public void setPeranSasaran(PeranSasaran peranSasaran) {
        this.peranSasaran = peranSasaran;
    }

    public Periode getPeriode() {
        periode = rencanaKinerjaSasaranController.getPeriode();
        return periode;
    }

    public void setPeriode(Periode periode) {
        this.periode = periode;
    }

    public Sasaran getSasaran() {
        peranSasaran = rencanaKinerjaSasaranController.getPeranSasaran();
        sasaran = peranSasaran.getSasaranFk();
        return sasaran;
    }

    public void setSasaran(Sasaran sasaran) {
        this.sasaran = sasaran;
    }

    public SasaranIndikatorKinerja getSasaranIndikator() {
        return sasaranIndikator;
    }

    public void setSasaranIndikator(SasaranIndikatorKinerja sasaranIndikator) {
        this.sasaranIndikator = sasaranIndikator;
    }

    public DataModel<SasaranIndikatorKinerja> getSasaranIndikators() {
        refreshSasaranIndikators();
        return sasaranIndikators;
    }

    public void setSasaranIndikators(DataModel<SasaranIndikatorKinerja> sasaranIndikators) {
        this.sasaranIndikators = sasaranIndikators;
    }

    public Runit getUnitKerja() {
        unitKerja = rencanaKinerjaSasaranController.getUnitKerja();
        return unitKerja;
    }

    public void setUnitKerja(Runit unitKerja) {
        this.unitKerja = unitKerja;
    }

    public PegawaiPeran getPegawaiPeran() {
        pegawaiPeran = rencanaKinerjaPeranController.getPegawaiPeran();
        return pegawaiPeran;
    }

    public void setPegawaiPeran(PegawaiPeran pegawaiPeran) {
        this.pegawaiPeran = pegawaiPeran;
    }

    public List<PegawaiPeran> getPegawaiPerans() {
        pegawaiPerans = (List<PegawaiPeran>) rencanaKinerjaPeranController.getRencanaKinerjaPegawai().getPegawaiPeranCollection();
        return pegawaiPerans;
    }

    public void setPegawaiPerans(List<PegawaiPeran> pegawaiPerans) {
        this.pegawaiPerans = pegawaiPerans;
    }

    public List<PeranSasaran> getPeranSasarans() {
        peranSasarans = (List<PeranSasaran>) getPegawaiPeran().getPeranSasaranCollection();
        return peranSasarans;
    }

    public void setPeranSasarans(List<PeranSasaran> peranSasarans) {
        this.peranSasarans = peranSasarans;
    }
}
