/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.controller.rencanakinerja;

import id.go.bpkp.ski.ejb.CrudEJB;
import id.go.bpkp.ski.entity.*;
import java.io.Serializable;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.SessionScoped;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.inject.Inject;
import javax.inject.Named;

/**
 *
 * @author phai
 */
@Named
@SessionScoped
public class RencanaKinerjaPeranController implements Serializable {
    
    @Inject
    private CrudEJB crudEJB;
    @Inject
    private RencanaKinerjaController rencanaKinerjaController;
    private Runit unitKerja;
    private Periode periode;
    private Rpegawai pegawai;
    private RencanaKinerjaPegawai rencanaKinerjaPegawai;
    private PegawaiPeran pegawaiPeran;
    private Peran peran;
    private DataModel<PegawaiPeran> pegawaiPerans;
    private KelompokPeran kelompokPeran;
    private List<KelompokPeran> kelompokPerans;
    private List<Peran> perans;
    
    @PostConstruct
    public void init() {
        System.err.println("===INIT===");
        unitKerja = rencanaKinerjaController.getUnitKerja();
        periode = rencanaKinerjaController.getPeriode();
        pegawai = rencanaKinerjaController.getPegawai();
        rencanaKinerjaPegawai = rencanaKinerjaController.getRencanaKinerjaPegawai();
        
        refreshPegawaiPerans();
    }
    
    @PreDestroy
    public void destroy() {
        System.err.println("===DESTROY===");
        unitKerja = null;
        periode = null;
        pegawai = null;
        pegawaiPeran = null;
        pegawaiPeran = null;
        pegawaiPerans = null;
        
        if (null != kelompokPerans) {
            kelompokPerans.clear();
            kelompokPerans = null;
        }
        
        if (null != perans) {
            perans.clear();
            perans = null;
        }
    }
    
    public void onChangeKelompokPeran() {
        perans = (List<Peran>) kelompokPeran.getPeranCollection();
    }
    
    public void onChangePeran() {
        pegawaiPeran.setPeranFk(peran);
    }
    
    public String add() {
        if (rencanaKinerjaPegawai != null) {
            pegawaiPeran = new PegawaiPeran();
            pegawaiPeran.setRencanaKinerjaPegawaiFk(rencanaKinerjaPegawai);
            kelompokPerans = crudEJB.findWithNamedQuery("KelompokPeran.findAll");
            peran = null;
            return "/rencanakinerja/peran/create?faces-redirect=true";
        } else {
            return "/rencanakinerja/list?faces-redirect=true";
        }
    }
    
    public String edit() {
        pegawaiPeran = pegawaiPerans.getRowData();
        peran = pegawaiPeran.getPeranFk();
        kelompokPeran = peran.getKelompokPeranFk();
        kelompokPerans = crudEJB.findWithNamedQuery("KelompokPeran.findAll");
        perans = (List<Peran>) kelompokPeran.getPeranCollection();
        return "/rencanakinerja/peran/edit?faces-redirect=true";
    }
    
    public String delete() {
        pegawaiPeran = pegawaiPerans.getRowData();
        return "/rencanakinerja/peran/delete?faces-redirect=true";
    }
    
    public String save() {
        if (pegawaiPeran != null) {
            if (pegawaiPeran.getPegawaiPeranPk() == null) {
                pegawaiPeran = crudEJB.create(pegawaiPeran);
            } else {
                pegawaiPeran = crudEJB.update(pegawaiPeran);
            }
        }
        refreshPegawaiPerans();
        return "/rencanakinerja/sasaran/list?faces-redirect=true";
    }
    
    public String remove() {
        crudEJB.delete(PegawaiPeran.class, pegawaiPeran.getPegawaiPeranPk());
        refreshPegawaiPerans();
        return "/rencanakinerja/peran/list?faces-redirect=true";
    }
    
    private void refreshPegawaiPerans() {
        rencanaKinerjaPegawai = crudEJB.find(RencanaKinerjaPegawai.class, getRencanaKinerjaPegawai().getRencanaKinerjaPegawaiPk());
        List<PegawaiPeran> listPegawaiPeran = (List<PegawaiPeran>) rencanaKinerjaPegawai.getPegawaiPeranCollection();
        pegawaiPerans = new ListDataModel<PegawaiPeran>(listPegawaiPeran);
    }
    
    public KelompokPeran getKelompokPeran() {
        return kelompokPeran;
    }
    
    public void setKelompokPeran(KelompokPeran kelompokPeran) {
        this.kelompokPeran = kelompokPeran;
    }
    
    public List<KelompokPeran> getKelompokPerans() {
        return kelompokPerans;
    }
    
    public void setKelompokPerans(List<KelompokPeran> kelompokPerans) {
        this.kelompokPerans = kelompokPerans;
    }
    
    public Rpegawai getPegawai() {
        pegawai = rencanaKinerjaController.getPegawai();
        return pegawai;
    }
    
    public void setPegawai(Rpegawai pegawai) {
        this.pegawai = pegawai;
    }
    
    public PegawaiPeran getPegawaiPeran() {
        return pegawaiPeran;
    }
    
    public void setPegawaiPeran(PegawaiPeran pegawaiPeran) {
        this.pegawaiPeran = pegawaiPeran;
    }
    
    public DataModel<PegawaiPeran> getPegawaiPerans() {
        refreshPegawaiPerans();
        return pegawaiPerans;
    }
    
    public void setPegawaiPerans(DataModel<PegawaiPeran> pegawaiPerans) {
        this.pegawaiPerans = pegawaiPerans;
    }
    
    public Peran getPeran() {
        return peran;
    }
    
    public void setPeran(Peran peran) {
        this.peran = peran;
    }
    
    public List<Peran> getPerans() {
        return perans;
    }
    
    public void setPerans(List<Peran> perans) {
        this.perans = perans;
    }
    
    public Periode getPeriode() {
        periode = rencanaKinerjaController.getPeriode();
        return periode;
    }
    
    public void setPeriode(Periode periode) {
        this.periode = periode;
    }
    
    public RencanaKinerjaPegawai getRencanaKinerjaPegawai() {
        rencanaKinerjaPegawai = rencanaKinerjaController.getRencanaKinerjaPegawai();
        return rencanaKinerjaPegawai;
    }
    
    public void setRencanaKinerjaPegawai(RencanaKinerjaPegawai rencanaKinerjaPegawai) {
        this.rencanaKinerjaPegawai = rencanaKinerjaPegawai;
    }
    
    public Runit getUnitKerja() {
        unitKerja = rencanaKinerjaController.getUnitKerja();
        return unitKerja;
    }
    
    public void setUnitKerja(Runit unitKerja) {
        this.unitKerja = unitKerja;
    }
}
