/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.controller.rencanakinerja;

import id.go.bpkp.ski.ejb.CrudEJB;
import id.go.bpkp.ski.entity.*;
import java.io.Serializable;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.SessionScoped;
import javax.faces.model.DataModel;
import javax.faces.model.ListDataModel;
import javax.inject.Inject;
import javax.inject.Named;

/**
 *
 * @author phai
 */
@Named
@SessionScoped
public class RencanaKinerjaSasaranController implements Serializable {

    @Inject
    private CrudEJB crudEJB;
    @Inject
    private RencanaKinerjaPeranController rencanaKinerjaPeranController;
    private Runit unitKerja;
    private Periode periode;
    private Rpegawai pegawai;
    private PegawaiPeran pegawaiPeran;
    private PeranSasaran peranSasaran;
    private Peran peran;
    private Sasaran sasaran;
    private DataModel<PeranSasaran> peranSasarans;
    private List<Sasaran> sasarans;
    private List<PegawaiPeran> pegawaiPerans;

    @PostConstruct
    public void init() {
        System.err.println("===INIT===");
        unitKerja = rencanaKinerjaPeranController.getUnitKerja();
        periode = rencanaKinerjaPeranController.getPeriode();
        pegawai = rencanaKinerjaPeranController.getPegawai();
        pegawaiPeran = rencanaKinerjaPeranController.getPegawaiPeran();
        peran = pegawaiPeran.getPeranFk();
        pegawaiPerans = (List<PegawaiPeran>) rencanaKinerjaPeranController.getRencanaKinerjaPegawai().getPegawaiPeranCollection();

        refreshPeranSasarans();
    }

    @PreDestroy
    public void destroy() {
        System.err.println("===DESTROY===");
        unitKerja = null;
        periode = null;
        pegawai = null;
        peranSasaran = null;
        peranSasarans = null;

        if (null != sasarans) {
            sasarans.clear();
            sasarans = null;
        }
    }

    public void onChangeSasaran() {
        peranSasaran.setSasaranFk(sasaran);
    }

    public void onChangePegawaiPeran() {
        rencanaKinerjaPeranController.setPegawaiPeran(pegawaiPeran);
        refreshPeranSasarans();
    }

    public String add() {
        if (pegawaiPeran != null) {
            peranSasaran = new PeranSasaran();
            peranSasaran.setPegawaiPeranFk(pegawaiPeran);
            sasarans = (List<Sasaran>) peran.getSasaranCollection();
            sasaran = null;
            return "/rencanakinerja/sasaran/create?faces-redirect=true";
        } else {
            return "/rencanakinerja/peran/list?faces-redirect=true";
        }
    }

    public String edit() {
        peranSasaran = peranSasarans.getRowData();
        sasaran = peranSasaran.getSasaranFk();
        sasarans = (List<Sasaran>) peran.getSasaranCollection();
        return "/rencanakinerja/sasaran/edit?faces-redirect=true";
    }

    public String delete() {
        peranSasaran = peranSasarans.getRowData();
        return "/rencanakinerja/sasaran/delete?faces-redirect=true";
    }

    public String save() {
        System.err.println("masuk save");
        if (peranSasaran != null) {
            if (peranSasaran.getPeranSasaranPk() == null) {
                peranSasaran = crudEJB.create(peranSasaran);
            } else {
                peranSasaran = crudEJB.update(peranSasaran);
            }
        }
        refreshPeranSasarans();

        return "/rencanakinerja/indikator/list?faces-redirect=true";
    }

    public String remove() {
        crudEJB.delete(PeranSasaran.class, getPeranSasaran().getPeranSasaranPk());
        refreshPeranSasarans();
        return "/rencanakinerja/sasaran/list?faces-redirect=true";
    }

    private void refreshPeranSasarans() {
        pegawaiPeran = crudEJB.find(PegawaiPeran.class, getPegawaiPeran().getPegawaiPeranPk());
        List<PeranSasaran> listPeranSasaran = (List<PeranSasaran>) pegawaiPeran.getPeranSasaranCollection();
        peranSasarans = new ListDataModel<PeranSasaran>(listPeranSasaran);
    }

    public Rpegawai getPegawai() {
        pegawai = rencanaKinerjaPeranController.getPegawai();
        return pegawai;
    }

    public void setPegawai(Rpegawai pegawai) {
        this.pegawai = pegawai;
    }

    public PegawaiPeran getPegawaiPeran() {
        pegawaiPeran = rencanaKinerjaPeranController.getPegawaiPeran();
        return pegawaiPeran;
    }

    public void setPegawaiPeran(PegawaiPeran pegawaiPeran) {
        this.pegawaiPeran = pegawaiPeran;
    }

    public Peran getPeran() {
        pegawaiPeran = rencanaKinerjaPeranController.getPegawaiPeran();
        peran = pegawaiPeran.getPeranFk();
        return peran;
    }

    public void setPeran(Peran peran) {
        this.peran = peran;
    }

    public PeranSasaran getPeranSasaran() {
        return peranSasaran;
    }

    public void setPeranSasaran(PeranSasaran peranSasaran) {
        this.peranSasaran = peranSasaran;
    }

    public DataModel<PeranSasaran> getPeranSasarans() {
        refreshPeranSasarans();
        return peranSasarans;
    }

    public void setPeranSasarans(DataModel<PeranSasaran> peranSasarans) {
        this.peranSasarans = peranSasarans;
    }

    public Periode getPeriode() {
        periode = rencanaKinerjaPeranController.getPeriode();
        return periode;
    }

    public void setPeriode(Periode periode) {
        this.periode = periode;
    }

    public Sasaran getSasaran() {
        return sasaran;
    }

    public void setSasaran(Sasaran sasaran) {
        this.sasaran = sasaran;
    }

    public List<Sasaran> getSasarans() {
        return sasarans;
    }

    public void setSasarans(List<Sasaran> sasarans) {
        this.sasarans = sasarans;
    }

    public Runit getUnitKerja() {
        unitKerja = rencanaKinerjaPeranController.getUnitKerja();
        return unitKerja;
    }

    public void setUnitKerja(Runit unitKerja) {
        this.unitKerja = unitKerja;
    }

    public List<PegawaiPeran> getPegawaiPerans() {
        pegawaiPerans = (List<PegawaiPeran>) rencanaKinerjaPeranController.getRencanaKinerjaPegawai().getPegawaiPeranCollection();
        return pegawaiPerans;
    }

    public void setPegawaiPerans(List<PegawaiPeran> pegawaiPerans) {
        this.pegawaiPerans = pegawaiPerans;
    }
}
