/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.entity;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author phai
 */
@Entity
@Table(name = "EXPLAIN_STATEMENT")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "ExplainStatement.findAll", query = "SELECT e FROM ExplainStatement e"),
    @NamedQuery(name = "ExplainStatement.findByExplainRequester", query = "SELECT e FROM ExplainStatement e WHERE e.explainStatementPK.explainRequester = :explainRequester"),
    @NamedQuery(name = "ExplainStatement.findByExplainTime", query = "SELECT e FROM ExplainStatement e WHERE e.explainStatementPK.explainTime = :explainTime"),
    @NamedQuery(name = "ExplainStatement.findBySourceName", query = "SELECT e FROM ExplainStatement e WHERE e.explainStatementPK.sourceName = :sourceName"),
    @NamedQuery(name = "ExplainStatement.findBySourceSchema", query = "SELECT e FROM ExplainStatement e WHERE e.explainStatementPK.sourceSchema = :sourceSchema"),
    @NamedQuery(name = "ExplainStatement.findBySourceVersion", query = "SELECT e FROM ExplainStatement e WHERE e.explainStatementPK.sourceVersion = :sourceVersion"),
    @NamedQuery(name = "ExplainStatement.findByExplainLevel", query = "SELECT e FROM ExplainStatement e WHERE e.explainStatementPK.explainLevel = :explainLevel"),
    @NamedQuery(name = "ExplainStatement.findByStmtno", query = "SELECT e FROM ExplainStatement e WHERE e.explainStatementPK.stmtno = :stmtno"),
    @NamedQuery(name = "ExplainStatement.findBySectno", query = "SELECT e FROM ExplainStatement e WHERE e.explainStatementPK.sectno = :sectno"),
    @NamedQuery(name = "ExplainStatement.findByQueryno", query = "SELECT e FROM ExplainStatement e WHERE e.queryno = :queryno"),
    @NamedQuery(name = "ExplainStatement.findByQuerytag", query = "SELECT e FROM ExplainStatement e WHERE e.querytag = :querytag"),
    @NamedQuery(name = "ExplainStatement.findByStatementType", query = "SELECT e FROM ExplainStatement e WHERE e.statementType = :statementType"),
    @NamedQuery(name = "ExplainStatement.findByUpdatable", query = "SELECT e FROM ExplainStatement e WHERE e.updatable = :updatable"),
    @NamedQuery(name = "ExplainStatement.findByDeletable", query = "SELECT e FROM ExplainStatement e WHERE e.deletable = :deletable"),
    @NamedQuery(name = "ExplainStatement.findByTotalCost", query = "SELECT e FROM ExplainStatement e WHERE e.totalCost = :totalCost"),
    @NamedQuery(name = "ExplainStatement.findByQueryDegree", query = "SELECT e FROM ExplainStatement e WHERE e.queryDegree = :queryDegree")})
public class ExplainStatement implements Serializable {
    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected ExplainStatementPK explainStatementPK;
    @Basic(optional = false)
    @NotNull
    @Column(name = "QUERYNO")
    private int queryno;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 20)
    @Column(name = "QUERYTAG")
    private String querytag;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 2)
    @Column(name = "STATEMENT_TYPE")
    private String statementType;
    @Basic(optional = false)
    @NotNull
    @Column(name = "UPDATABLE")
    private char updatable;
    @Basic(optional = false)
    @NotNull
    @Column(name = "DELETABLE")
    private char deletable;
    @Basic(optional = false)
    @NotNull
    @Column(name = "TOTAL_COST")
    private double totalCost;
    @Basic(optional = false)
    @NotNull
    @Lob
    @Column(name = "STATEMENT_TEXT")
    private String statementText;
    @Lob
    @Column(name = "SNAPSHOT")
    private Serializable snapshot;
    @Basic(optional = false)
    @NotNull
    @Column(name = "QUERY_DEGREE")
    private int queryDegree;

    public ExplainStatement() {
    }

    public ExplainStatement(ExplainStatementPK explainStatementPK) {
        this.explainStatementPK = explainStatementPK;
    }

    public ExplainStatement(ExplainStatementPK explainStatementPK, int queryno, String querytag, String statementType, char updatable, char deletable, double totalCost, String statementText, int queryDegree) {
        this.explainStatementPK = explainStatementPK;
        this.queryno = queryno;
        this.querytag = querytag;
        this.statementType = statementType;
        this.updatable = updatable;
        this.deletable = deletable;
        this.totalCost = totalCost;
        this.statementText = statementText;
        this.queryDegree = queryDegree;
    }

    public ExplainStatement(String explainRequester, Date explainTime, String sourceName, String sourceSchema, String sourceVersion, char explainLevel, int stmtno, int sectno) {
        this.explainStatementPK = new ExplainStatementPK(explainRequester, explainTime, sourceName, sourceSchema, sourceVersion, explainLevel, stmtno, sectno);
    }

    public ExplainStatementPK getExplainStatementPK() {
        return explainStatementPK;
    }

    public void setExplainStatementPK(ExplainStatementPK explainStatementPK) {
        this.explainStatementPK = explainStatementPK;
    }

    public int getQueryno() {
        return queryno;
    }

    public void setQueryno(int queryno) {
        this.queryno = queryno;
    }

    public String getQuerytag() {
        return querytag;
    }

    public void setQuerytag(String querytag) {
        this.querytag = querytag;
    }

    public String getStatementType() {
        return statementType;
    }

    public void setStatementType(String statementType) {
        this.statementType = statementType;
    }

    public char getUpdatable() {
        return updatable;
    }

    public void setUpdatable(char updatable) {
        this.updatable = updatable;
    }

    public char getDeletable() {
        return deletable;
    }

    public void setDeletable(char deletable) {
        this.deletable = deletable;
    }

    public double getTotalCost() {
        return totalCost;
    }

    public void setTotalCost(double totalCost) {
        this.totalCost = totalCost;
    }

    public String getStatementText() {
        return statementText;
    }

    public void setStatementText(String statementText) {
        this.statementText = statementText;
    }

    public Serializable getSnapshot() {
        return snapshot;
    }

    public void setSnapshot(Serializable snapshot) {
        this.snapshot = snapshot;
    }

    public int getQueryDegree() {
        return queryDegree;
    }

    public void setQueryDegree(int queryDegree) {
        this.queryDegree = queryDegree;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (explainStatementPK != null ? explainStatementPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ExplainStatement)) {
            return false;
        }
        ExplainStatement other = (ExplainStatement) object;
        if ((this.explainStatementPK == null && other.explainStatementPK != null) || (this.explainStatementPK != null && !this.explainStatementPK.equals(other.explainStatementPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "id.go.bpkp.ski.entity.ExplainStatement[ explainStatementPK=" + explainStatementPK + " ]";
    }
    
}
