/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.entity;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

/**
 *
 * @author phai
 */
@Embeddable
public class ExplainStatementPK implements Serializable {
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 128)
    @Column(name = "EXPLAIN_REQUESTER")
    private String explainRequester;
    @Basic(optional = false)
    @NotNull
    @Column(name = "EXPLAIN_TIME")
    @Temporal(TemporalType.TIMESTAMP)
    private Date explainTime;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 128)
    @Column(name = "SOURCE_NAME")
    private String sourceName;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 128)
    @Column(name = "SOURCE_SCHEMA")
    private String sourceSchema;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 64)
    @Column(name = "SOURCE_VERSION")
    private String sourceVersion;
    @Basic(optional = false)
    @NotNull
    @Column(name = "EXPLAIN_LEVEL")
    private char explainLevel;
    @Basic(optional = false)
    @NotNull
    @Column(name = "STMTNO")
    private int stmtno;
    @Basic(optional = false)
    @NotNull
    @Column(name = "SECTNO")
    private int sectno;

    public ExplainStatementPK() {
    }

    public ExplainStatementPK(String explainRequester, Date explainTime, String sourceName, String sourceSchema, String sourceVersion, char explainLevel, int stmtno, int sectno) {
        this.explainRequester = explainRequester;
        this.explainTime = explainTime;
        this.sourceName = sourceName;
        this.sourceSchema = sourceSchema;
        this.sourceVersion = sourceVersion;
        this.explainLevel = explainLevel;
        this.stmtno = stmtno;
        this.sectno = sectno;
    }

    public String getExplainRequester() {
        return explainRequester;
    }

    public void setExplainRequester(String explainRequester) {
        this.explainRequester = explainRequester;
    }

    public Date getExplainTime() {
        return explainTime;
    }

    public void setExplainTime(Date explainTime) {
        this.explainTime = explainTime;
    }

    public String getSourceName() {
        return sourceName;
    }

    public void setSourceName(String sourceName) {
        this.sourceName = sourceName;
    }

    public String getSourceSchema() {
        return sourceSchema;
    }

    public void setSourceSchema(String sourceSchema) {
        this.sourceSchema = sourceSchema;
    }

    public String getSourceVersion() {
        return sourceVersion;
    }

    public void setSourceVersion(String sourceVersion) {
        this.sourceVersion = sourceVersion;
    }

    public char getExplainLevel() {
        return explainLevel;
    }

    public void setExplainLevel(char explainLevel) {
        this.explainLevel = explainLevel;
    }

    public int getStmtno() {
        return stmtno;
    }

    public void setStmtno(int stmtno) {
        this.stmtno = stmtno;
    }

    public int getSectno() {
        return sectno;
    }

    public void setSectno(int sectno) {
        this.sectno = sectno;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (explainRequester != null ? explainRequester.hashCode() : 0);
        hash += (explainTime != null ? explainTime.hashCode() : 0);
        hash += (sourceName != null ? sourceName.hashCode() : 0);
        hash += (sourceSchema != null ? sourceSchema.hashCode() : 0);
        hash += (sourceVersion != null ? sourceVersion.hashCode() : 0);
        hash += (int) explainLevel;
        hash += (int) stmtno;
        hash += (int) sectno;
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof ExplainStatementPK)) {
            return false;
        }
        ExplainStatementPK other = (ExplainStatementPK) object;
        if ((this.explainRequester == null && other.explainRequester != null) || (this.explainRequester != null && !this.explainRequester.equals(other.explainRequester))) {
            return false;
        }
        if ((this.explainTime == null && other.explainTime != null) || (this.explainTime != null && !this.explainTime.equals(other.explainTime))) {
            return false;
        }
        if ((this.sourceName == null && other.sourceName != null) || (this.sourceName != null && !this.sourceName.equals(other.sourceName))) {
            return false;
        }
        if ((this.sourceSchema == null && other.sourceSchema != null) || (this.sourceSchema != null && !this.sourceSchema.equals(other.sourceSchema))) {
            return false;
        }
        if ((this.sourceVersion == null && other.sourceVersion != null) || (this.sourceVersion != null && !this.sourceVersion.equals(other.sourceVersion))) {
            return false;
        }
        if (this.explainLevel != other.explainLevel) {
            return false;
        }
        if (this.stmtno != other.stmtno) {
            return false;
        }
        if (this.sectno != other.sectno) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "id.go.bpkp.ski.entity.ExplainStatementPK[ explainRequester=" + explainRequester + ", explainTime=" + explainTime + ", sourceName=" + sourceName + ", sourceSchema=" + sourceSchema + ", sourceVersion=" + sourceVersion + ", explainLevel=" + explainLevel + ", stmtno=" + stmtno + ", sectno=" + sectno + " ]";
    }
    
}
