/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.entity;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author phai
 */
@Entity
@Table(name = "PERAN")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Peran.findAll", query = "SELECT p FROM Peran p"),
    @NamedQuery(name = "Peran.findByPeranPk", query = "SELECT p FROM Peran p WHERE p.peranPk = :peranPk"),
    @NamedQuery(name = "Peran.findByPeranNama", query = "SELECT p FROM Peran p WHERE p.peranNama = :peranNama")})
public class Peran implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Column(name = "PERAN_PK")
    private Long peranPk;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 255)
    @Column(name = "PERAN_NAMA")
    private String peranNama;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "peranFk")
    private Collection<PegawaiPeran> pegawaiPeranCollection;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "peranFk")
    private Collection<Sasaran> sasaranCollection;
    @JoinColumn(name = "KELOMPOK_PERAN_FK", referencedColumnName = "KELOMPOK_PERAN_PK")
    @ManyToOne(optional = false)
    private KelompokPeran kelompokPeranFk;

    public Peran() {
    }

    public Peran(Long peranPk) {
        this.peranPk = peranPk;
    }

    public Peran(Long peranPk, String peranNama) {
        this.peranPk = peranPk;
        this.peranNama = peranNama;
    }

    public Long getPeranPk() {
        return peranPk;
    }

    public void setPeranPk(Long peranPk) {
        this.peranPk = peranPk;
    }

    public String getPeranNama() {
        return peranNama;
    }

    public void setPeranNama(String peranNama) {
        this.peranNama = peranNama;
    }

    @XmlTransient
    public Collection<PegawaiPeran> getPegawaiPeranCollection() {
        return pegawaiPeranCollection;
    }

    public void setPegawaiPeranCollection(Collection<PegawaiPeran> pegawaiPeranCollection) {
        this.pegawaiPeranCollection = pegawaiPeranCollection;
    }

    @XmlTransient
    public Collection<Sasaran> getSasaranCollection() {
        return sasaranCollection;
    }

    public void setSasaranCollection(Collection<Sasaran> sasaranCollection) {
        this.sasaranCollection = sasaranCollection;
    }

    public KelompokPeran getKelompokPeranFk() {
        return kelompokPeranFk;
    }

    public void setKelompokPeranFk(KelompokPeran kelompokPeranFk) {
        this.kelompokPeranFk = kelompokPeranFk;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (peranPk != null ? peranPk.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Peran)) {
            return false;
        }
        Peran other = (Peran) object;
        if ((this.peranPk == null && other.peranPk != null) || (this.peranPk != null && !this.peranPk.equals(other.peranPk))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "id.go.bpkp.ski.entity.Peran[ peranPk=" + peranPk + " ]";
    }
    
}
