/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.entity;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author phai
 */
@Entity
@Table(name = "REVIEW")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Review.findAll", query = "SELECT r FROM Review r"),
    @NamedQuery(name = "Review.findByReviewPk", query = "SELECT r FROM Review r WHERE r.reviewPk = :reviewPk"),
    @NamedQuery(name = "Review.findByReviewNo", query = "SELECT r FROM Review r WHERE r.reviewNo = :reviewNo"),
    @NamedQuery(name = "Review.findByReviewTanggal", query = "SELECT r FROM Review r WHERE r.reviewTanggal = :reviewTanggal"),
    @NamedQuery(name = "Review.findByReviewCatatan", query = "SELECT r FROM Review r WHERE r.reviewCatatan = :reviewCatatan")})
public class Review implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Column(name = "REVIEW_PK")
    private Long reviewPk;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 255)
    @Column(name = "REVIEW_NO")
    private String reviewNo;
    @Basic(optional = false)
    @NotNull
    @Column(name = "REVIEW_TANGGAL")
    @Temporal(TemporalType.DATE)
    private Date reviewTanggal;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 255)
    @Column(name = "REVIEW_CATATAN")
    private String reviewCatatan;
    @JoinColumn(name = "RENCANA_KINERJA_FK", referencedColumnName = "RENCANA_KINERJA_PK")
    @ManyToOne(optional = false)
    private RencanaKinerja rencanaKinerjaFk;

    public Review() {
    }

    public Review(Long reviewPk) {
        this.reviewPk = reviewPk;
    }

    public Review(Long reviewPk, String reviewNo, Date reviewTanggal, String reviewCatatan) {
        this.reviewPk = reviewPk;
        this.reviewNo = reviewNo;
        this.reviewTanggal = reviewTanggal;
        this.reviewCatatan = reviewCatatan;
    }

    public Long getReviewPk() {
        return reviewPk;
    }

    public void setReviewPk(Long reviewPk) {
        this.reviewPk = reviewPk;
    }

    public String getReviewNo() {
        return reviewNo;
    }

    public void setReviewNo(String reviewNo) {
        this.reviewNo = reviewNo;
    }

    public Date getReviewTanggal() {
        return reviewTanggal;
    }

    public void setReviewTanggal(Date reviewTanggal) {
        this.reviewTanggal = reviewTanggal;
    }

    public String getReviewCatatan() {
        return reviewCatatan;
    }

    public void setReviewCatatan(String reviewCatatan) {
        this.reviewCatatan = reviewCatatan;
    }

    public RencanaKinerja getRencanaKinerjaFk() {
        return rencanaKinerjaFk;
    }

    public void setRencanaKinerjaFk(RencanaKinerja rencanaKinerjaFk) {
        this.rencanaKinerjaFk = rencanaKinerjaFk;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (reviewPk != null ? reviewPk.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Review)) {
            return false;
        }
        Review other = (Review) object;
        if ((this.reviewPk == null && other.reviewPk != null) || (this.reviewPk != null && !this.reviewPk.equals(other.reviewPk))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "id.go.bpkp.ski.entity.Review[ reviewPk=" + reviewPk + " ]";
    }
    
}
