/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package id.go.bpkp.ski.entity;

import java.io.Serializable;
import java.util.Collection;
import javax.persistence.*;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;

/**
 *
 * @author phai
 */
@Entity
@Table(name = "SASARAN")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Sasaran.findAll", query = "SELECT s FROM Sasaran s"),
    @NamedQuery(name = "Sasaran.findBySasaranPk", query = "SELECT s FROM Sasaran s WHERE s.sasaranPk = :sasaranPk"),
    @NamedQuery(name = "Sasaran.findBySasaranNama", query = "SELECT s FROM Sasaran s WHERE s.sasaranNama = :sasaranNama"),
    @NamedQuery(name = "Sasaran.findBySasaranSatuan", query = "SELECT s FROM Sasaran s WHERE s.sasaranSatuan = :sasaranSatuan")})
public class Sasaran implements Serializable {
    private static final long serialVersionUID = 1L;
    @Id
    @Basic(optional = false)
    @NotNull
    @Column(name = "SASARAN_PK")
    private Long sasaranPk;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 255)
    @Column(name = "SASARAN_NAMA")
    private String sasaranNama;
    @Basic(optional = false)
    @NotNull
    @Size(min = 1, max = 255)
    @Column(name = "SASARAN_SATUAN")
    private String sasaranSatuan;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "sasaranFk")
    private Collection<PeranSasaran> peranSasaranCollection;
    @JoinColumn(name = "PERAN_FK", referencedColumnName = "PERAN_PK")
    @ManyToOne(optional = false)
    private Peran peranFk;
    @OneToMany(cascade = CascadeType.ALL, mappedBy = "sasaranFk")
    private Collection<IndikatorKinerja> indikatorKinerjaCollection;

    public Sasaran() {
    }

    public Sasaran(Long sasaranPk) {
        this.sasaranPk = sasaranPk;
    }

    public Sasaran(Long sasaranPk, String sasaranNama, String sasaranSatuan) {
        this.sasaranPk = sasaranPk;
        this.sasaranNama = sasaranNama;
        this.sasaranSatuan = sasaranSatuan;
    }

    public Long getSasaranPk() {
        return sasaranPk;
    }

    public void setSasaranPk(Long sasaranPk) {
        this.sasaranPk = sasaranPk;
    }

    public String getSasaranNama() {
        return sasaranNama;
    }

    public void setSasaranNama(String sasaranNama) {
        this.sasaranNama = sasaranNama;
    }

    public String getSasaranSatuan() {
        return sasaranSatuan;
    }

    public void setSasaranSatuan(String sasaranSatuan) {
        this.sasaranSatuan = sasaranSatuan;
    }

    @XmlTransient
    public Collection<PeranSasaran> getPeranSasaranCollection() {
        return peranSasaranCollection;
    }

    public void setPeranSasaranCollection(Collection<PeranSasaran> peranSasaranCollection) {
        this.peranSasaranCollection = peranSasaranCollection;
    }

    public Peran getPeranFk() {
        return peranFk;
    }

    public void setPeranFk(Peran peranFk) {
        this.peranFk = peranFk;
    }

    @XmlTransient
    public Collection<IndikatorKinerja> getIndikatorKinerjaCollection() {
        return indikatorKinerjaCollection;
    }

    public void setIndikatorKinerjaCollection(Collection<IndikatorKinerja> indikatorKinerjaCollection) {
        this.indikatorKinerjaCollection = indikatorKinerjaCollection;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (sasaranPk != null ? sasaranPk.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Sasaran)) {
            return false;
        }
        Sasaran other = (Sasaran) object;
        if ((this.sasaranPk == null && other.sasaranPk != null) || (this.sasaranPk != null && !this.sasaranPk.equals(other.sasaranPk))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "id.go.bpkp.ski.entity.Sasaran[ sasaranPk=" + sasaranPk + " ]";
    }
    
}
